<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.3"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: include/core/GameEngine.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectalign">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.3 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search",'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_3d69f64eaf81436fe2b22361382717e5.html">core</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle"><div class="title">GameEngine.hpp</div></div>
</div><!--header-->
<div class="contents">
<a href="GameEngine_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="preprocessor">#pragma once</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span> </div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="preprocessor">#include &quot;Event.hpp&quot;</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="preprocessor">#include &quot;<a class="code" href="GameEngine_8hpp.html">GameEngine.hpp</a>&quot;</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="preprocessor">#include &quot;gamestates/GameState.hpp&quot;</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="preprocessor">#include &lt;SFML/Graphics/Drawable.hpp&gt;</span></div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span> </div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno"><a class="line" href="namespacegg.html">    8</a></span><span class="keyword">namespace </span><a class="code hl_namespace" href="namespacegg.html">gg</a></div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span>{</div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span> </div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="keyword">class </span>GameState;</div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span> </div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno"><a class="line" href="classgg_1_1GameEngine.html">   13</a></span><span class="keyword">class </span><a class="code hl_class" href="classgg_1_1GameEngine.html">GameEngine</a></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span>{</div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span>  <span class="keyword">private</span>:</div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span>    <span class="keyword">static</span> std::stack&lt;GameState *&gt; mStates;</div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span> </div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span>  <span class="keyword">public</span>:</div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno"><a class="line" href="classgg_1_1GameEngine.html#a674fec65e7cc736d53b80a62149ccb5a">   23</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1GameEngine.html#a674fec65e7cc736d53b80a62149ccb5a">Init</a>();</div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno"><a class="line" href="classgg_1_1GameEngine.html#a080186cb7aba33d72ffe3591dc076742">   28</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1GameEngine.html#a080186cb7aba33d72ffe3591dc076742">Destroy</a>();</div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span> </div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno"><a class="line" href="classgg_1_1GameEngine.html#a0c2d2187296c29983a4583e98597637a">   35</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1GameEngine.html#a0c2d2187296c29983a4583e98597637a">ChangeState</a>(GameState *state);</div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno"><a class="line" href="classgg_1_1GameEngine.html#a5876ec21d7676e824973beae3101ed3b">   41</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1GameEngine.html#a5876ec21d7676e824973beae3101ed3b">PushState</a>(GameState *state);</div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno"><a class="line" href="classgg_1_1GameEngine.html#aabd0a746f0479397458cb025c2b7207d">   46</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1GameEngine.html#aabd0a746f0479397458cb025c2b7207d">PopState</a>();</div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span>  </div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno"><a class="line" href="classgg_1_1GameEngine.html#af2fd746ff3c3426861968289d2ac9bb0">   53</a></span>    <span class="keyword">static</span> <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1GameEngine.html#af2fd746ff3c3426861968289d2ac9bb0">CurrentState</a>() -&gt; GameState *;</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span> </div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno"><a class="line" href="classgg_1_1GameEngine.html#afa9e36edde0d2dc1f47da6f3ec970468">   60</a></span>    <span class="keyword">static</span> <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1GameEngine.html#afa9e36edde0d2dc1f47da6f3ec970468">PreviousState</a>() -&gt; GameState *;</div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span> </div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno"><a class="line" href="classgg_1_1GameEngine.html#ad88dee00a8684a67020f53e57fa2d126">   62</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1GameEngine.html#ad88dee00a8684a67020f53e57fa2d126">Update</a>();</div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno"><a class="line" href="classgg_1_1GameEngine.html#acc0e937275f5dd88fcd5a45e42e058a5">   63</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1GameEngine.html#acc0e937275f5dd88fcd5a45e42e058a5">Render</a>(sf::RenderTarget &amp;target, sf::RenderStates states);</div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>};</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span> </div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>} <span class="comment">// namespace gg</span></div>
<div class="ttc" id="aGameEngine_8hpp_html"><div class="ttname"><a href="GameEngine_8hpp.html">GameEngine.hpp</a></div></div>
<div class="ttc" id="aclassgg_1_1GameEngine_html"><div class="ttname"><a href="classgg_1_1GameEngine.html">gg::GameEngine</a></div><div class="ttdef"><b>Definition:</b> GameEngine.hpp:14</div></div>
<div class="ttc" id="aclassgg_1_1GameEngine_html_a080186cb7aba33d72ffe3591dc076742"><div class="ttname"><a href="classgg_1_1GameEngine.html#a080186cb7aba33d72ffe3591dc076742">gg::GameEngine::Destroy</a></div><div class="ttdeci">static void Destroy()</div><div class="ttdoc">Deinitializes game engine.</div></div>
<div class="ttc" id="aclassgg_1_1GameEngine_html_a0c2d2187296c29983a4583e98597637a"><div class="ttname"><a href="classgg_1_1GameEngine.html#a0c2d2187296c29983a4583e98597637a">gg::GameEngine::ChangeState</a></div><div class="ttdeci">static void ChangeState(GameState *state)</div><div class="ttdoc">Remove current state and change it to state provided as the argument.</div></div>
<div class="ttc" id="aclassgg_1_1GameEngine_html_a5876ec21d7676e824973beae3101ed3b"><div class="ttname"><a href="classgg_1_1GameEngine.html#a5876ec21d7676e824973beae3101ed3b">gg::GameEngine::PushState</a></div><div class="ttdeci">static void PushState(GameState *state)</div><div class="ttdoc">Pushes state on top of the stack of states and makes it an active state.</div></div>
<div class="ttc" id="aclassgg_1_1GameEngine_html_a674fec65e7cc736d53b80a62149ccb5a"><div class="ttname"><a href="classgg_1_1GameEngine.html#a674fec65e7cc736d53b80a62149ccb5a">gg::GameEngine::Init</a></div><div class="ttdeci">static void Init()</div><div class="ttdoc">Initializes game engine.</div></div>
<div class="ttc" id="aclassgg_1_1GameEngine_html_aabd0a746f0479397458cb025c2b7207d"><div class="ttname"><a href="classgg_1_1GameEngine.html#aabd0a746f0479397458cb025c2b7207d">gg::GameEngine::PopState</a></div><div class="ttdeci">static void PopState()</div><div class="ttdoc">Removes current state.</div></div>
<div class="ttc" id="aclassgg_1_1GameEngine_html_acc0e937275f5dd88fcd5a45e42e058a5"><div class="ttname"><a href="classgg_1_1GameEngine.html#acc0e937275f5dd88fcd5a45e42e058a5">gg::GameEngine::Render</a></div><div class="ttdeci">static void Render(sf::RenderTarget &amp;target, sf::RenderStates states)</div></div>
<div class="ttc" id="aclassgg_1_1GameEngine_html_ad88dee00a8684a67020f53e57fa2d126"><div class="ttname"><a href="classgg_1_1GameEngine.html#ad88dee00a8684a67020f53e57fa2d126">gg::GameEngine::Update</a></div><div class="ttdeci">static void Update()</div></div>
<div class="ttc" id="aclassgg_1_1GameEngine_html_af2fd746ff3c3426861968289d2ac9bb0"><div class="ttname"><a href="classgg_1_1GameEngine.html#af2fd746ff3c3426861968289d2ac9bb0">gg::GameEngine::CurrentState</a></div><div class="ttdeci">static auto CurrentState() -&gt; GameState *</div><div class="ttdoc">Returns state that is currently active.</div></div>
<div class="ttc" id="aclassgg_1_1GameEngine_html_afa9e36edde0d2dc1f47da6f3ec970468"><div class="ttname"><a href="classgg_1_1GameEngine.html#afa9e36edde0d2dc1f47da6f3ec970468">gg::GameEngine::PreviousState</a></div><div class="ttdeci">static auto PreviousState() -&gt; GameState *</div><div class="ttdoc">Returns state that was active before currently active state.</div></div>
<div class="ttc" id="anamespacegg_html"><div class="ttname"><a href="namespacegg.html">gg</a></div><div class="ttdef"><b>Definition:</b> GameEngine.hpp:9</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.3
</small></address>
</body>
</html>
